<script setup lang="ts">
import { ref } from 'vue'
import { useHomeStore } from '../store/home'
import type { ExpenseDetails } from '../types/expense'
import BarChart from './charts/BarChart.vue'
import { ReportService } from '@/services/report'
import { useLoadingStore } from '@/stores/loading'

const store = useHomeStore()
const expenseData = ref<ExpenseDetails[]>()
const loader = useLoadingStore()

async function fetchExpenseBranch(id: number) {
  expenseData.value = await ReportService.getExpenseBranch(id)
}
</script>

<template>
  <v-card class="pa-5" rounded="lg">
    <p>Details of branch {{ store.selectBranch?.name }}</p>
    <v-select
      :items="store.getBranch"
      :item-title="'name'"
      :item-value="'id'"
      variant="outlined"
      rounded="pill"
      density="compact"
      class="my-2"
      @update:model-value="
        (v) => {
          fetchExpenseBranch(v)
        }
      "
    ></v-select>
    <v-skeleton-loader v-if="loader.isLoading" type="card"></v-skeleton-loader>
    <BarChart
      v-else
      :data="expenseData?.map((item) => item.totalWorth) ?? []"
      :labels="expenseData?.map((item) => item.name) ?? []"
    ></BarChart>
  </v-card>
</template>
